/* myWindowController */

#import <Cocoa/Cocoa.h>
#import <AppKit/AppKit.h>

#include <Carbon/Carbon.h>

@interface myWindowController : NSObject
{

    int currentPageNumber;
    IBOutlet NSTextView * tabSource;
	IBOutlet id animate;
	IBOutlet id messages;
	IBOutlet NSButton * useDoubleStaff;
    	IBOutlet NSButton * useSecondVoice;
	IBOutlet id fontSize;
	IBOutlet NSWindow * mainWindow;
	IBOutlet NSPanel * convertingPanel;
	IBOutlet NSTextField * convertingPanelText;
	IBOutlet NSWindow * previewWindow;
	IBOutlet NSImageView * previewImage;
	IBOutlet NSScrollView * previewScrollView;
    IBOutlet NSView * rightPanel;
    IBOutlet NSSplitView * splitView;
	IBOutlet id recentFilesMenu;
	IBOutlet id formatSelector;
	
	IBOutlet NSButton * zoomController_left;
	IBOutlet id zoomController_right;
	IBOutlet id zoomController_up;
	IBOutlet id zoomController_down;
	IBOutlet id zoomController_center;

    IBOutlet NSTextField * pageXofXTextField;
    IBOutlet NSButton * pageLeftButton;
    IBOutlet NSButton * pageRightButton;

    IBOutlet NSDrawer * controlsDrawer;

    BOOL firstRaster;
    BOOL silentUpdate;
	BOOL doneGeneratingPS;
	BOOL lala;
	NSImage * currentImage;
	
    NSString *thisBundlePath;
    
    NSString *tabPath;
    
	IBOutlet NSProgressIndicator * convertingPanelProgressIndicator;
	
	IBOutlet id zoomLevelLabel;
    
    NSString * savePathRoot;
	
	BOOL observingNSTaskDidTerminateNotification;
	BOOL observingNSFileHandleReadCompletionNotification;
	
	NSWindow * shieldWindow;

	NSMutableDictionary *recentFilesDictionary;
	BOOL previewOnly;
	BOOL showMessageWindow;
	BOOL workingOnConversion;
	NSPipe* myPipe;
	NSFileHandle* tabOutput;
	NSTask* generateTAB;
	NSMutableArray *listenerArray;
	NSEnumerator *enumerator;
	NSString * typesFormat;
	NSString * currentName;
	
	NSMutableArray *oscPorts;
	
	//BOOL AddBadgeToItem(NSString* path,NSData* tag);
	
	NSUserDefaults		*prefs;
	
}


-(IBAction)toggleZoomControlVisibility:(id)sender;
-(IBAction)zoomPreviewIN:(id)sender;
-(IBAction)zoomPreviewOUT:(id)sender;
-(IBAction)resetPreviewZoom:(id)sender;

-(IBAction)zoomPreviewTOP:(id)sender;
-(IBAction)zoomPreviewMIDDLE:(id)sender;
-(IBAction)zoomPreviewBOTTOM:(id)sender;

-(IBAction)pageBack:(id)sender;
-(IBAction)pageForward:(id)sender;

-(IBAction)choosePageNumber1:(id)sender;
-(IBAction)choosePageNumber2:(id)sender;
-(IBAction)choosePageNumber3:(id)sender;
-(IBAction)choosePageNumber4:(id)sender;
-(IBAction)choosePageNumber5:(id)sender;

- (IBAction)hideBackground:(id)sender;

- (IBAction)selectOutputFormat:(id)sender;
- (IBAction)playMidi:(id)sender;
- (IBAction)newFromTemplate:(id)sender;
- (IBAction)newDoc:(id)sender;
- (IBAction)changeFontSize:(id)sender;
-(void)clearWorkspace;
-(void)firstRun;
- (IBAction)simpleSave:(id)sender;
- (IBAction)clearLog:(id)sender;
- (IBAction)doIt:(id)sender;
- (IBAction)doPreview:(id)sender;
- (IBAction)doPreviewSilently:(id)sender;
- (IBAction)importFile:(id)sender;
- (IBAction)convertFile:(id)sender;
- (IBAction)saveCurrentfile:(id)sender;
- (IBAction)toggleMessageDisplay:(id)sender;
- (IBAction)openReadme:(id)sender;
- (IBAction)loadSample:(id)sender;
-(IBAction)addSecondVoice:(id)sender;

-(void)updateRecentFilesMenu:(NSString *)newFile;

@end
